# How-to: Test PTTH_QUIC

## Initial setup

- Open 3 terminals in `crates/ptth_quic`
- Use `export RUST_LOG=ptth_quic_relay_server=debug` to enable debug logging
for the terminal that will run the relay server (P3)
- Use `export RUST_LOG=ptth_quic=debug` for the terminal that
will run the end server (P4)
- Use `export RUST_LOG=ptth_quic_client=debug` for the terminal that
will run the client (P2)

When the relay server is running, use curl to get the list of connected
end servers: `curl 127.0.0.1:4004`

## Test loop - Happy path

- Start a relay `cargo run --bin ptth_quic_relay_server`
- Verify that the relay has no end servers connected 
- Start an end server `cargo run --bin ptth_quic_end_server -- --debug-echo`
- Verify that the end server connected
- Start a client `cargo run --bin ptth_quic_client`
- Connect to the client and verify that the debug echo server is running
`nc 127.0.0.1 30381`
